chapter\<open>Evaluation\<close>

text\<open>Term Annotation Antiquotations (TA) can be evaluated with the help of the value* command.\<close>

theory 
  Instance_Value_Normalization
imports 
  "Isabelle_DOF-tests.TermAntiquotations"
  "Isabelle_DOF.scholarly_paper"
  (*"Isabelle_DOF.CENELEC_50128"*)
begin

(*<*)
(* Ontology example for mathematical papers *)
declare[[invariants_checking = true]]
(*declare[[invariants_checking_with_tactics = true]]*)

doc_class myauthor =
  email :: "string" <= "''''"

value \<open>{2::int} = {1::int}\<close>
text*[church::myauthor, email="\<open>church@lambda.org\<close>"]\<open>\<close>
text*[churche::myauthor, email="\<open>churche@lambda.org\<close>"]\<open>\<close>
value*\<open>@{myauthor \<open>church\<close>}\<close>
print_doc_items
ML\<open>val t = @{docitem "church"}\<close>
doc_class mytext_section =
  authored_by :: "myauthor set" <= "{}"
  level :: "int option" <= "None"
doc_class myintro = mytext_section +
  authored_by :: "myauthor set"  <= "UNIV" 
  uses :: "string set"
  invariant author_set :: "authored_by \<sigma> \<noteq> {}"
  (*invariant author_finite :: "authored_by \<sigma> = {@{myauthor \<open>church\<close>}}"*)
  invariant author_finite :: "\<forall>x \<in> set(@{myauthor-instances}). x \<noteq> @{myauthor \<open>churche\<close>}"
  (*invariant author_finite :: "finite (authored_by \<sigma>)"*)
  invariant author_finite2 :: "authored_by \<sigma> \<noteq> {}"
  invariant force_level :: "the (level \<sigma>) > 1"
find_theorems name:"author_finite_inv_def"
text*[myintrotest::myintro, authored_by ="{@{myauthor \<open>church\<close>}, @{myauthor \<open>church\<close>}}", level="Some 2"]\<open>\<close>
value*\<open>authored_by @{myintro \<open>myintrotest\<close>}\<close>
term\<open>authored_by \<sigma> =
     insert (myauthor.make
             paper_myauthor_tag_attribute_Attribute_Not_Initialized
             paper_myauthor_email_Attribute_Not_Initialized
             \<lparr>myauthor.email := [], myauthor.email := ''church@lambda.org''\<rparr>) bot\<close>
term \<open>\<lambda>\<sigma>. authored_by \<sigma> =
      insert ( myauthor.make
               paper_myauthor_tag_attribute_Attribute_Not_Initialized
               paper_myauthor_email_Attribute_Not_Initialized
               \<lparr>myauthor.email := [], myauthor.email := ''church@lambda.org''\<rparr>)
             bot
\<close>
term \<open>myauthor.make
               paper_myauthor_tag_attribute_Attribute_Not_Initialized
               paper_myauthor_email_Attribute_Not_Initialized
               \<lparr>myauthor.email := [], myauthor.email := ''church@lambda.org''\<rparr>
             
\<close>
ML\<open>
val ctxt = @{context}
val thy = @{theory}
val schemeN = "_scheme"
val cid_long = "paper.myintro"
fun update_attribute_type thy cid_long class_scheme_ty
            (Const (s, Type (st,[ty, ty'])) $ t) =
              let
                val cid = Long_Name.qualifier s
              in case DOF_core.get_doc_class_global cid thy of
                     NONE => Const (s, Type(st,[ty, ty']))
                             $ (update_attribute_type thy cid_long class_scheme_ty t)
                   | SOME _ => if DOF_core.is_subclass_global thy cid_long cid then
                                 Const(s, Type(st,[class_scheme_ty, ty']))
                                 $ (update_attribute_type thy cid_long class_scheme_ty t)
                               else 
                                 Const (s, Type(st,[ty, ty']))
                                 $ (update_attribute_type thy cid_long class_scheme_ty t)
              end
          | update_attribute_type thy cid_long class_scheme_ty (t $ t') =
              (update_attribute_type thy cid_long class_scheme_ty t)
              $ (update_attribute_type thy cid_long class_scheme_ty t')
          | update_attribute_type thy cid_long class_scheme_ty (Abs(s, ty, t)) =
              Abs(s, ty, update_attribute_type thy cid_long class_scheme_ty t)
          | update_attribute_type _ cid_long class_scheme_ty (Free(s, ty)) = if s = invariantN 
                                                                     then Free (s, class_scheme_ty)
                                                                     else Free (s, ty)
          | update_attribute_type _ cid_long _ t = t
(*val (Const (s, Type (st,[ty, ty'])) $ t) = inv_term_test*)
val inv_ty = Syntax.read_typ (Proof_Context.init_global thy)
                                     (Name.aT ^ " " ^ cid_long ^ schemeN)
val inv = "authored_by \<sigma> = {@{myauthor \<open>church\<close>}}"
val pos = \<^here>
val inv_term = Syntax.read_term (Proof_Context.init_global thy) inv
val _ = writeln("inv_term: " ^ Syntax.string_of_term  (Proof_Context.init_global thy) inv_term)
val inv_term_test = DOF_core.transduce_term_global {mk_elaboration=true} (inv_term, pos) thy
val _ = writeln("inv_term_test: " ^ Syntax.string_of_term  (Proof_Context.init_global thy) inv_term_test)
val inv_term' = update_attribute_type thy cid_long inv_ty inv_term_test
val _ = writeln("inv_term': " ^ Syntax.string_of_term  (Proof_Context.init_global thy) inv_term')
val abs_term = Term.lambda (Free (invariantN, inv_ty)) inv_term'
val _ = writeln("abs_term: " ^ Syntax.string_of_term  (Proof_Context.init_global thy) abs_term)
\<close>
ML\<open>
 
val thy = @{theory}
val ctxt = @{context}
val un = Syntax.read_term ctxt "12::int"
val schemeN = "_scheme"
val cid_long = "paper.myintro"
val read_cond = Syntax.read_term ctxt
         ("\<lambda>\<sigma>. authored_by \<sigma> ="
          ^ "insert (myauthor.make"
          ^ " paper_myauthor_tag_attribute_Attribute_Not_Initialized"
          ^ " paper_myauthor_email_Attribute_Not_Initialized"
          ^ " \<lparr>myauthor.email := [], myauthor.email := ''church@lambda.org''\<rparr>) bot")
val read_cond = Syntax.read_term ctxt
         ("\<lambda>\<sigma>. authored_by \<sigma> ="
          ^ "insert (myauthor.make (1::int) ''church@lambda.org'')"
          ^ " bot")
val inv_ty = Syntax.read_typ (Proof_Context.init_global thy)
                                     (Name.aT ^ " " ^ cid_long ^ schemeN)
val eq_inv_ty = inv_ty --> HOLogic.boolT
val f_sty = eq_inv_ty
val lbl = "author_finite'"
val cond_suffix = "_inv"
val binding = Binding.make (lbl,\<^here>)
fun meta_eq_const T = Const (\<^const_name>\<open>Pure.eq\<close>, T --> T --> propT);
fun mk_meta_eq (t, u) = meta_eq_const (fastype_of t) $ t $ u;
val bdg = Binding.suffix_name cond_suffix binding
val eq =  mk_meta_eq(Free(Binding.name_of bdg, f_sty),read_cond)
val _ = writeln(Syntax.string_of_term  (Proof_Context.init_global thy) eq)
\<close>
find_consts name:"authored_by"
find_consts name:"author_finite"
find_consts name:"*email*"
find_consts name:"*level*"
find_consts name:"force_level_inv"
find_theorems name:"HOL.refl"
print_theorems
print_doc_items
ML\<open>
datatype ref = dattyperef;
\<close>

doc_class myclaim = myintro +
  based_on :: "string list"
doc_class mytechnical = mytext_section +
  formal_results :: "thm list" 

datatype kind = expert_opinion | argument | "proof"

doc_class myresult = mytechnical +
  evidence :: kind
  property :: "thm list" <= "[]"
  invariant has_property :: "evidence \<sigma> = proof \<longleftrightarrow> property \<sigma> \<noteq> []"
doc_class myconclusion = mytext_section +
  establish :: "(myclaim \<times> myresult) set"
(*  invariant establish_defined :: "\<forall> x. x \<in> Domain (establish \<sigma>)
                      \<longrightarrow> (\<exists> y \<in> Range (establish \<sigma>). (x, y) \<in> establish \<sigma>)"*)

  invariant establish_defined2 :: "\<forall> x. x \<in> Domain (establish \<sigma>)
                      \<longrightarrow> (\<exists> y \<in> Range (establish \<sigma>). (x, y) \<in> establish \<sigma>)"

declare[[invariants_checking = true]]
declare[[invariants_checking_with_tactics = true]]



text*[proof1::myresult, evidence = "proof", property="[@{thm \<open>HOL.refl\<close>}]"]\<open>\<close>

text*[proof2::myresult, evidence = "proof", property="[@{thm \<open>HOL.sym\<close>}]"]\<open>\<close>

term*\<open>@{myauthor \<open>church\<close>}\<close>
(*term*\<open>@{myauthor \<open>churche\<close>}\<close>*)

value*\<open>email @{myauthor \<open>church\<close>}\<close>
(*value*\<open>email @{myauthor \<open>churche\<close>}\<close>*)

(*assert*\<open>@{myresult \<open>proof1\<close>} = @{myresult \<open>proof2\<close>}\<close>*)

(*text*[intro1::myintro, authored_by = "{@{myauthor \<open>church\<close>}}", level = "Some 0"]\<open>\<close>*)

(*text*[claimNotion::myclaim, authored_by = "{@{myauthor \<open>church\<close>}}", based_on= "[\<open>Notion1\<close>, \<open>Notion2\<close>]", level = "Some 0"]\<open>\<close>*)

value*\<open>authored_by (myintro.make (1::int) {@{myauthor \<open>church\<close>}} (Some 2) {\<open>test1\<close>, \<open>test2\<close>}) = {@{myauthor \<open>church\<close>}}\<close>
text*[intro2::myintro, authored_by = "{@{myauthor \<open>church\<close>}}", level = "Some 2"]\<open>\<close>

value*\<open>authored_by @{myintro \<open>intro2\<close>} = {@{myauthor \<open>church\<close>}}\<close>
declare[[invariants_checking = false]]
declare[[invariants_checking_with_tactics = false]]
(*>*)

term \<open>-6::int\<close>
print_doc_items
ML\<open>
val t = HOLogic.mk_number @{typ "int"} (serial ())
\<close>
ML\<open>
(*val thy = @{theory}*)
val {input_term,...} = the (DOF_core.get_object_global "xcv1" @{theory})
\<close>
end